import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.util.Scanner;
import java.io.IOException;

class Main {

    private static void main_orig(String[] args) {
        Entiers integer = new Entiers(5);

        integer.inserer(1);

        integer.afficher();

        integer.inserer(12);

        integer.afficher();

        integer.inserer(3);

        integer.afficher();

        integer.inserer(0);

        integer.inserer(1);

        integer.afficher();

        integer.supprimer(12);

        integer.afficher();
        System.out.println("Current size " + integer.getCurrentSize());

        integer.supprimer(1);

        integer.afficher();
        System.out.println("Current size " + integer.getCurrentSize());

    }

    private static void main_A(String[] args) {
        String className = null;
        Scanner uInput = null;
        try {
            uInput = new Scanner(System.in);
            System.out.println("Saisir le nom de la classe à inspecter:");
            className = uInput.nextLine();
        }
        catch (Exception e) {
            System.out.println("Erreur:");
            e.printStackTrace();
        }
        finally {
            uInput.close();
        }

        Class cl = null;
        try {
            cl = Class.forName(className);
        }
        catch (ClassNotFoundException e) {
            System.out.println("Entered class name do not exist.");
            System.exit(-1);
        }

        Field[] fields = cl.getFields();
        Method[] methods = cl.getMethods();

        for (int i = 0; i < fields.length; i++) {
            System.out.println(fields[i]);
        }

        for (int i = 0; i < methods.length; i++) {
            System.out.println(methods[i]);
        }
    }

    private static void main_B(String[] args) {
        String name = Entiers.class.getName();
        Class cl = null;
        Entiers o = null;
        try {
            cl = Class.forName(name);
            o = new Entiers(100);
        }
        catch (ClassNotFoundException e) {
            System.out.println("Class name do not exist.");
            System.exit(-1);
        }

        Scanner uInput = null;
        try {
            uInput = new Scanner(System.in);
            System.out.println("Saisir le nom de la methode à invoquer:");
            String method = uInput.nextLine();
            //TODO: one can build the input list from the method arguments list and types
            System.out.println("Saisir l'argument entier paramètre de la méthode:");
            int integer = uInput.nextInt();
            Method m = cl.getMethod(method, new Class[]{Integer.class});
            m.invoke(o, integer);
        }
        catch (Exception e) {
            System.out.println("Erreur:");
            e.printStackTrace();
        }
        finally {
            try {
                Method mDisplay = cl.getMethod("afficher");
                mDisplay.invoke(o);
            }
            catch (NoSuchMethodException e) {
                e.printStackTrace();
            }
            catch (IllegalAccessException e) {
                e.printStackTrace();
            }
            catch (InvocationTargetException e) {
                e.printStackTrace();
            }
            uInput.close();
        }
    }

    /**
     * The main() function
     * @param String[] args main() function arguments array
     */
    public static void main(String[] args) {
        main_A(args);
    }
}
